%% dataclean; 
load MS15-282Data.mat;
% Clean data input submitted to the JMCB on January 29, 2020, including the following variables:   

% 'kw_tp10_y10fit_07181990_12312018_daily'
% from Fed Board "feds200533_KW_TP_Feb 22 2019.xlsx" estimates from Kim-Wright (2005) Three-Factor term structure model, daily, July 18, 1990 to Dec. 31, 2018.
% Col. 1-4: year, quarter, month, day;
% Col. 5:  Estiamted 10-year bond term premium;
% Col. 6:  Fitted value of 10-year zero-coupon Treasury bond yield.
[quarterlyseries_avg, monthlyseries_avg,dailyseries,quarterlyseries_eop,monthlyseries_eop]=d2qm(kw_tp10_y10fit_07181990_12312018_daily);
kw_tp10_y10fit_90m7_18m12_eop = monthlyseries_eop;
kw_tp10_y10fit_90q3_18q4_eop  = quarterlyseries_eop;

% 'kw_tp10_y10fit_800102_130930'
% daily Kim-Wright 10-year term premium and model-fitted value of 10-year rate, Jan. 2 1980 to Sep 30, 2013.
[kw_tp10_y10fit_90q1_13q3_avg,kw_tp10_y10fit_90m1_13m9_avg,kw_tp10_y10fit_900102_130930,kw_tp10_y10fit_90q1_13q3_eop,kw_tp10_y10fit_90m1_13m9_eop] = d2qm(kw_tp10_y10fit_800102_130930(2610:end,:));
% kw_tp10_y10fit_90q1_13q3 = kw_tp10_y10fit_90q1_13q3_eop;
% kw_tp10_y10fit_90m1_13m9 = kw_tp10_y10fit_90m1_13m9_eop;
% kw_tp10_90m1_13m9 = kw_tp10_y10fit_90m1_13m9(:,1:3);        % Year, month, KW TP10 from Jan 90 to Sep 13, end of period;
% kw_exp10_90m1_13m9= [kw_tp10_y10fit_90m1_13m9(:,1:2),kw_tp10_y10fit_90m1_13m9(:,4)-kw_tp10_y10fit_90m1_13m9(:,3)];   % KW exp10 from Jan 90 to Sep 13.

kw_tp10_y10fit_90q1_18q4_eop  = [kw_tp10_y10fit_90q1_13q3_eop(1:2,:);kw_tp10_y10fit_90q3_18q4_eop]; % Year, month, KW_tp10 and KW_y10fit, 1990:m1 to 2018:m12, End of Month  
kw_tp10_y10fit_90m1_18m12_eop = [kw_tp10_y10fit_90m1_13m9_eop(1:6,:);kw_tp10_y10fit_90m7_18m12_eop];% Year, quarter, KW_tp10 and KW_y10fit, 1990:q1 to 2018:q4, End of Quarter   
kw_tp10_90m1_18m12 = kw_tp10_y10fit_90m1_18m12_eop(:,1:3);        % Year, month, KW TP10 from Jan 1990 to Dec 2018, end of period;
kw_y10fit_90m1_18m12= [kw_tp10_y10fit_90m1_18m12_eop(:,1:2),kw_tp10_y10fit_90m1_18m12_eop(:,4)]; % Year, month, KW y10fit from Jan 1990 to Dec 2018, end of period; 
kw_exp10_90m1_18m12= [kw_tp10_y10fit_90m1_18m12_eop(:,1:2),kw_tp10_y10fit_90m1_18m12_eop(:,4)-kw_tp10_y10fit_90m1_18m12_eop(:,3)];   % Year, month, KW exp10 from Jan 90 to Dec 2018, end of period; 

% 'y1toy10_900102_181231_daily'
% Fed Board's estimate of zero-coupon bond yields, from one-year to ten-year, Jan 2, 1990 to Dec. 31, 2018, 7235 daily obs; 
% Col. 1-4: year, quarter, month, day;
% Col. 5-14: 1-year to 10-year zero-coupon Treasury bond yields.
[quarterlyseries_avg, monthlyseries_avg,dailyseries,quarterlyseries_eop,monthlyseries_eop]=d2qm(y1toy10_900102_181231_daily);    
y1toy10_90q1_18q4 = quarterlyseries_eop;
y1toy10_90m1_18m12 = monthlyseries_eop; % y1 to y10 zero-coupon Treasury yields 
y10_90q1_18q4 = [y1toy10_90q1_18q4(:,1:2),y1toy10_90q1_18q4(:,12)];
y10_90m1_18m12 = [y1toy10_90m1_18m12(:,1:2),y1toy10_90m1_18m12(:,12)];   % Year, Month/Quarter, 10-year Treasury yield, End of Period.

% 'dkm_exp10_90m1_13m9'
% monthly series of D'Amico-Kim-Wei model estimate of 10-year expected short rate, Jan. 1990 to Sep. 2013, monthly avg, 285-by-3 matrix.

% 'dkm_tp10_90m1_13m9'     
% monthly series of D'Amico-Kim-Wei model estimate of 10-year term premium, Jan. 1990 to Sep. 2013, monthly avg, 285285-by-3 matrix.

% 'acm_tp10_900102_130930'
% daily series of Adrian-Crump-Moench model estimate of 10-year term premium, Jan 02 1990 to Sep 30 2013, 5923-by-5 matrix.
[acm_tp10_90q1_13q3_avg,acm_tp10_90m1_13m9_avg,acm_tp10_900102_130930,acm_tp10_90q1_13q3_eop,acm_tp10_90m1_13m9_eop] = d2qm(acm_tp10_900102_130930); % monthly avg and daily series of the ACM tp10, 285-by-3 for monthly series.
acm_tp10_90q1_13q3 = acm_tp10_90q1_13q3_eop; % acm_tp10_90q1_13q3 = acm_tp10_90q1_13q3_avg; 
acm_tp10_90m1_13m9 = acm_tp10_90m1_13m9_eop; % acm_tp10_90m1_13m9 = acm_tp10_90m1_13m9_avg;

% tp_cr2016sr_980102_170929
% daily series of term premiums of 1-y, 2-y, ..., 10-y from Christensen & Rudebusch (2016) "Shadow Rate" model;
[tp_cr2016sr_98q1_17q3_avg,tp_cr2016sr_98m1_17m9_avg,tp_cr2016sr_980102_170929,tp_cr2016sr_98q1_17q3_eop,tp_cr2016sr_98m1_17m9_eop]=d2qm(tp_cr2016sr_980102_170929);    % Quarterly, Monthly, and Daily series of TP, on 1- to 10-y maturities;
tp_cr2016sr_98q1_17q3 = tp_cr2016sr_98q1_17q3_eop;
tp_cr2016sr_98m1_17m9 = tp_cr2016sr_98m1_17m9_eop;
% %% Col. 1: year; col. 2: quarter/month; col. 3-12: Term Premiums over the 1-y to 10-y maturities.  

% 'exp_cr2016sr_980102_170929'
% daily series of Expected Short Rate over next 1-y, 2-y, ..., 10-y from Christensen & Rudebusch (2016) "Shadow Rate" model;
[exp_cr2016sr_98q1_17q3_avg,exp_cr2016sr_98m1_17m9_avg,exp_cr2016sr_980102_170929,exp_cr2016sr_98q1_17q3_eop,exp_cr2016sr_98m1_17m9_eop]=d2qm(exp_cr2016sr_980102_170929);    % Quarterly, Monthly, and Daily series of Exp. Short Rate, on 1- to 10-y maturities;
exp_cr2016sr_98q1_17q3 = exp_cr2016sr_98q1_17q3_avg;
exp_cr2016sr_98m1_17m9 = exp_cr2016sr_98m1_17m9_avg;
% exp_cr2016sr_98q1_17q3 = exp_cr2016sr_98q1_17q3_eop;
% exp_cr2016sr_98m1_17m9 = exp_cr2016sr_98m1_17m9_eop;
% %% Col. 1: year; col. 2: quarter/month; col. 3-12: exp short rate over the next 1-y to 10-y. Note that this is the expected short rate over 1-year horizon, not the avg over the next N years.  
exp10_cr2016sr_98m1_17m9 = mean(exp_cr2016sr_98m1_17m9(:,3:end),2);
exp10_cr2016sr_98m1_17m9 = [exp_cr2016sr_98m1_17m9(:,1:2),exp10_cr2016sr_98m1_17m9];    % year, month, and the avg. exp. short rate over the next 10 years from CR2016 Shadow Rate model, 1998:M1 to 2017:M9

% 'euro64vol_900102_181005.mat'
% Fed Board's estimates of implied volatility from six-month-ahead Eurodollar futures options. 
% Col. 1-4: year, quarter, month, day;
% Col. 5:  Estiamted Implied volatility of 6-month-ahead Eurodollar futures option (180 days)
% Col. 6:  Estiamted Implied volatility of 4-month-ahead Eurodollar futures option (120 days)
[quarterlyseries_avg, monthlyseries_avg,dailyseries,quarterlyseries_eop,monthlyseries_eop]=d2qm(euro64vol_900102_181005);
euro64vol_90q1_18q3 = quarterlyseries_avg(1:end-1,:); % 2018:Q4 only has 5 days of observations and is thus deleted  
euro64vol_90m1_18m9 = monthlyseries_avg(1:end-1,:); % Oct 2018 only has 5 days of observations and is thus deleted.  
euro6vol_90m1_18m9 = monthlyseries_avg(1:end-1,1:3); % Year, month, and Implied volatility of 6-month-ahead Eurodollar futures option. 
euro6vol_90m1_18m9 = [euro6vol_90m1_18m9(1:95,:);[1997 12 mean(euro6vol_90m1_18m9(95:96,3))];euro6vol_90m1_18m9(96:end,:)];
                   % Dec. 1997 obs are missing in the original daily series, so use the avg of Nov. 97 and Jan 98 instead. 


% 'pdv_r_soma_90m1_23m12'
% 408-by-1 monthly PDV series, Jan 1990 to Dec 2023, nonzero starting Nov. 2008. 

% 'pdv_r_soma_n_90m1_23m12'
% 408-by-1 monthly PDV_N series, Jan 1990 to Dec 2023, nonzero starting Nov. 2008 and ends in Aug 2014, since on 09/17/2014
% the FOMC's "Policy Normalization Principles and Plans" states that it does not "anticipate selling agency mortgage-backed securities as part of the normalization 
% process," and thus de-linking the connection between forward guidance and sell-off.

% 'unemp_rt_90m1_18m12'
% Unemployment rate, monthly series, 348 months from 90:m1 to 18:m12.

% 'nairu_lr_90m1_18m12'
% Long-run Nairu, 90:m1 to 18:m12, from nairu_lr_49q1_29q4_feb19version.mat above;

% 'nairu_sr_90m1_18m12'
% Short-run Nairu,90:m1 to 18:m12, from nairu_sr_49q1_29q4_feb19version.mat above;

% 'consconf_90m1_18m12'
% Conference Board's consumer confidence index, overall, 285 months from 90:m1 to 18:m12;

% 'consconf_exp_90m1_18m12'
% The Expectations Component of Conference Board's consumer confidence index, 348 months from 90:m1 to 18:m12;

% 'lrinfl_cpi_92m1_18m12'
% 10-year overall CPI inflation forecast, median of responses, SPF, 324 months from 92:m1 to 18:m12;

% 'srinfl_90m1_18m12'
% 12-month ahead inflation expectation, Reuters/University of Michigan Survey of Consumers. 90:m1 to 18:m12;

% 'corepcepi_89m1_18m11'
% Core PCEPI, 89:M1 to 18:M11.
corepcepi_infl_90m1_18m11 = (log(corepcepi_89m1_18m11(13:end))-log(corepcepi_89m1_18m11(1:end-12)))*100;    % 12-month core PCEPI inflation.

% 'cpiinfl_disp_90m1_18m12'
% monthly conversion of the quarterly dispersion of the 4th quarter ahead CPI inflation from Survey of Professional Forecasters, 90:m1 to 18:m12, 348 months, from Dispersion_CPI SPF March 1 2019.xlsx

% 'logpgdp_disp_90m1_18m12'
% monthly conversion of the quarerly dispersion of 4-Q ahead log-diff of GDP deflator, 90:m1 to 18:m12, 348 months, from Dispersion_PGDP SPF March 1 2019.xls, sheet "D3". This measures the disp of 4-Q infl exp.   

% 'unemp_disp_90m1_18m12'
% monthly conversion of the quarterly dispersion of 4-Q ahead unemployment rate from SPF, 90:m1 to 13:m9, 348 months, from Dispersion_UNEMP SPF March 1 2019.xls, sheet "D1";

% 'logrgdp_disp_90m1_18m12'
% monthly conversion of the quarerly dispersion of 4-Q ahead log-diff of real GDP level, 90:m1 to 13:m9, 345 months, from Dispersion_RGDP SPF March 1 2019.xlsx, sheet "D3".
             
% 'move_90m1_18m12'
% Merryl Lynch MOVE index (1-month) in basis points, monthy average from Haver, 90:m1 to 18:m12.

% 'vix_90m1_18m12'
% CBOE VIX index, in basis points, monthy average from Haver, 90:m1 to 18:m12. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                    
% Monthly regressions, full sample period jan 1990 to Sep 2018;  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tp10 = kw_tp10_90m1_18m12(1:end-3,3); % dkm_tp10_90m1_13m9(:,3);%tp_cr2016sr_98m1_17m9(1:12*15+9,12);  %acm_tp10_90m1_13m9(:,3); y10_90m1_18m12(1:end-3,3); 
%tp10 = kw_exp10_90m1_18m12(1:end-3,3); % dkm_exp10_90m1_13m9(:,3); % exp10_cr2016sr_98m1_17m9(1:12*15+9,3); y10_90m1_13m9(:,3)-acm_tp10_90m1_13m9(:,3); 

pdv = pdv_r_soma_90m1_23m12(1:345); % 1990:m1 to 2018:m9.
pdv_n = pdv_r_soma_n_90m1_23m12(1:345); % the PDV_N counter-factural measure.

utgap= unemp_rt_90m1_18m12(1:end-3)-nairu_sr_90m1_18m12(1:end-3);% Unemployment rate gap, in percentage points, use short-run Nairu
% utgap= unemp_rt_90m1_18m12(1:end-3)-nairu_lr_90m1_18m12(1:end-3); % Unemployment rate gap, in percentage points, use long-run Nairu. This generates little difference from estimates based on short-run Nairu.
ygap = utgap;

consconf = consconf_exp_90m1_18m12(1:end-3);   % consconf_90m1_13m9;    Consumer confidence.
lrinfl = lrinfl_cpi_92m1_18m12(1:end-3);       % 10-year ahead CPI inflation forecast.
srinfl = srinfl_90m1_18m12(1:end-3);           % 12-month ahead infl expectations.
infl = corepcepi_infl_90m1_18m11(1:end-2);     % current 12-month core PCEPI inflation, in percentage points.

infl_disp    = logpgdp_disp_90m1_18m12(1:end-3);      % cpiinfl_disp_90m1_13m9;   %[zeros(24,1);corepcepi_minfl_std_92m1_13m9];   % Dispersion of 4-Q ahead CPI inflation projections from the SPF.
unemp_disp   = unemp_disp_90m1_18m12(1:end-3);                        % Dispersion of 4-Q ahead unemployment rate projections from the SPF;
logrgdp_disp = logrgdp_disp_90m1_18m12(1:end-3);      % [zeros(24,1);rgdp_gt_std_92m1_13m9];                % Dispersion of 4-Q ahead log-diff of real GDP level, i.e., next 4-Q real growth rate, in percentage points.

[coefs,scores,variances,t2]= pca([infl_disp,unemp_disp,logrgdp_disp]);
pc1_macvol = scores(:,1);    % 1st principal component of macroeconomic volatilities, mean zero, 285 monthly obs, 90:M1 to 13:M9.

move = move_90m1_18m12(1:end-3)/100;                   % MOVE index, in percentage points.
vix  = vix_90m1_18m12(1:end-3)/100;                    % VIX index, in percentage points.
euro6vol=euro6vol_90m1_18m9(:,3);                      % Implied Volatility of 6-month Eurodollar futures option.

[coefs,scores,variances,t2]= pca([move,vix,euro6vol]);
%% scores(:,1) and f1_finvol are identical, same for the other two factors. 
pc1_finvol = scores(:,1);    % 1st principal component of financial volatilities, mean zero, 285 monthly obs, 90:M1 to 13:M9.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   ESTIMATION    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% Level Regressions %%%%%%%%%%%% 
% whole sample: 92:M1 to 18:M9
ydata = tp10(25:end);       
xdata = [ones(345-25+1,1),ygap(25:end),consconf(25:end),lrinfl(1:end),srinfl(25:end),infl(25:end),logrgdp_disp(25:end),unemp_disp(25:end),infl_disp(25:end),move(25:end),vix(25:end),euro6vol(25:end),pdv(25:end)];

% %% Christensen Rudebusch model sample begins in Jan. 1998, so the estimation sample here for their series can only start in Jan 1998.
% ydata = tp10;
% xdata = [ones(345-25+1,1),ygap(25:end),consconf(25:end),lrinfl(1:end),srinfl(25:end),infl(25:end),logrgdp_disp(25:end),unemp_disp(25:end),infl_disp(25:end),move(25:end),vix(25:end),euro6vol(25:end),pdv(25:end)];
% xdata = xdata(12*6+1:285-25+1,:);
% %%% For Christensen Rudebusch model, estimation sample runs from Jan. 98 to Sep. 2013. 
% 
% % pre-crisis sample,  from 92:M1 to 08:M8
% t1 = 224;       % t1=211 if the crisis began in Aug 2007. 25:224 is from 92:M1 to 08:M8;  25:211 is from 92:M1 to 07:M7. 
% ydata = tp10(25:t1);     
% xdata = [ones(t1-25+1,1),ygap(25:t1),consconf(25:t1),lrinfl(1:t1-24),srinfl(25:t1),infl(25:t1),logrgdp_disp(25:t1),unemp_disp(25:t1),infl_disp(25:t1),move(25:t1),vix(25:t1),euro6vol(25:t1)];
% % crisis sample: from 08:M9 to 18:M9;
% t2 = 225;           % t2 = 225 if the crisis began in Sep 2008, or t2 = 212 if the crisis began in Aug 2007. 
% ydata = tp10(t2:end);
% xdata = [ones(345-t2+1,1),ygap(t2:end),consconf(t2:end),lrinfl(t2-24:end),srinfl(t2:end),infl(t2:end),logrgdp_disp(t2:end),unemp_disp(t2:end),infl_disp(t2:end),move(t2:end),vix(t2:end),euro6vol(t2:end),pdv(t2:end)];
% 
% % Using principal components of macro, fin volatilities and/or without infl measures. 
% % whole sample: 92:M1 to 13:M9
% ydata = tp10(25:end);
% xdata = [ones(345-25+1,1),ygap(25:end),consconf(25:end),lrinfl(1:end),srinfl(25:end),infl(25:end),pc1_macvol(25:end),pc1_finvol(25:end),pdv(25:end)];
% %xdata = [ones(345-25+1,1),ygap(25:end),consconf(25:end),pc1_infl,pc1_macvol(25:end),pc1_finvol(25:end),pdv(25:end)];
% % pre-crisis sample,  from 92:M1 to 08:M8
% t1 = 224;       % t1=211 if the crisis began in Aug 2007. 25:224 is from 92:M1 to 08:M8;  25:211 is from 92:M1 to 07:M7. 
% ydata = tp10(25:t1);     
% xdata = [ones(t1-25+1,1),ygap(25:t1),consconf(25:t1),lrinfl(1:t1-24),srinfl(25:t1),infl(25:t1),pc1_macvol(25:t1),pc1_finvol(25:t1)];
% % crisis sample: from 08:M9 to 13:M9;
% t2 = 225;           % t2 = 225 if the crisis began in Sep 2008, or t2 = 212 if the crisis began in Aug 2007. 
% ydata = tp10(t2:end);
% xdata = [ones(345-t2+1,1),ygap(t2:end),consconf(t2:end),lrinfl(t2-24:end),srinfl(t2:end),infl(t2:end),pc1_macvol(t2:end),pc1_finvol(t2:end),pdv(t2:end)];
% 
% %%%%%%%%%% Differencing Regressions; %%%%%%%%
% % whole sample: 92:M1 to 18:M9
% ydata = tp10(25:end)-tp10(24:end-1);
% xdata = [ones(345-25+1,1),ygap(25:end)-ygap(24:end-1),consconf(25:end)-consconf(24:end-1),[0;lrinfl(2:end)-lrinfl(1:end-1)],srinfl(25:end)-srinfl(24:end-1),infl(25:end)-infl(24:end-1),logrgdp_disp(25:end)-logrgdp_disp(24:end-1),unemp_disp(25:end)-unemp_disp(24:end-1),infl_disp(25:end)-infl_disp(24:end-1),move(25:end)-move(24:end-1),vix(25:end)-vix(24:end-1),euro6vol(25:end)-euro6vol(24:end-1),pdv(25:end)-pdv(24:end-1)];
% %% Christensen Rudebusch model sample begins in Jan. 1998, so the estimation sample here for their series can only start in Jan 1998. Ends in 2013:M9
% ydata = tp10(2:end)-tp10(1:end-1);
% xdata = [ones(285-25+1,1),ygap(25:end)-ygap(24:end-1),consconf(25:end)-consconf(24:end-1),[0;lrinfl(2:end)-lrinfl(1:end-1)],srinfl(25:end)-srinfl(24:end-1),infl(25:end)-infl(24:end-1),logrgdp_disp(25:end)-logrgdp_disp(24:end-1),unemp_disp(25:end)-unemp_disp(24:end-1),infl_disp(25:end)-infl_disp(24:end-1),move(25:end)-move(24:end-1),vix(25:end)-vix(24:end-1),euro6vol(25:end)-euro6vol(24:end-1),pdv(25:end)-pdv(24:end-1)];
% xdata = xdata(12*6+1+1:end,:);
% %%% For Christensen Rudebusch model, estimation sample runs from Jan. 98 to Sep. 2013, and differencing regression sample runs from Feb. 98 to Sep. 2013. 
% 
% % pre-crisis sample,  from 92:M1 to 08:M8
% t1 = 224;       % t1=211 if the crisis began in Aug 2007. 25:224 is from 92:M1 to 08:M8;  25:211 is from 92:M1 to 07:M7. 
% ydata = tp10(25:t1)-tp10(24:t1-1);
% xdata = [ones(t1-25+1,1),ygap(25:t1)-ygap(24:t1-1),consconf(25:t1)-consconf(24:t1-1),[0;lrinfl(2:t1-24)-lrinfl(1:t1-24-1)],srinfl(25:t1)-srinfl(24:t1-1),infl(25:t1)-infl(24:t1-1),logrgdp_disp(25:t1)-logrgdp_disp(24:t1-1),unemp_disp(25:t1)-unemp_disp(24:t1-1),infl_disp(25:t1)-infl_disp(24:t1-1),move(25:t1)-move(24:t1-1),vix(25:t1)-vix(24:t1-1),euro6vol(25:t1)-euro6vol(24:t1-1)];
% % crisis sample: from 08:M9 to 18:M9;
% t2 = 225;           % t2 = 225 if the crisis began in Sep 2008, or t2 = 212 if the crisis began in Aug 2007. 
% ydata = tp10(t2:end)-tp10(t2-1:end-1);
% xdata = [ones(345-t2+1,1),ygap(t2:end)-ygap(t2-1:end-1),consconf(t2:end)-consconf(t2-1:end-1),lrinfl(t2-24:end)-lrinfl(t2-24-1:end-1),srinfl(t2:end)-srinfl(t2-1:end-1),infl(t2:end)-infl(t2-1:end-1),logrgdp_disp(t2:end)-logrgdp_disp(t2-1:end-1),unemp_disp(t2:end)-unemp_disp(t2-1:end-1),infl_disp(t2:end)-infl_disp(t2-1:end-1),move(t2:end)-move(t2-1:end-1),vix(t2:end)-vix(t2-1:end-1),euro6vol(t2:end)-euro6vol(t2-1:end-1),pdv(t2:end)-pdv(t2-1:end-1)];
% 
% % Using principal components of macro, fin volatilities and/or without infl measures. 
% % whole sample: 92:M1 to 13:M9
% ydata = tp10(25:end)-tp10(24:end-1);
% xdata = [ones(345-25+1,1),ygap(25:end)-ygap(24:end-1),consconf(25:end)-consconf(24:end-1),[0;lrinfl(2:end)-lrinfl(1:end-1)],srinfl(25:end)-srinfl(24:end-1),infl(25:end)-infl(24:end-1),pc1_macvol(25:end)-pc1_macvol(24:end-1),pc1_finvol(25:end)-pc1_finvol(24:end-1),pdv(25:end)-pdv(24:end-1)];
% % pre-crisis sample,  from 92:M1 to 08:M8
% t1 = 224;       % t1=211 if the crisis began in Aug 2007. 25:224 is from 92:M1 to 08:M8;  25:211 is from 92:M1 to 07:M7. 
% ydata = tp10(25:t1)-tp10(24:t1-1);
% xdata = [ones(t1-25+1,1),ygap(25:t1)-ygap(24:t1-1),consconf(25:t1)-consconf(24:t1-1),[0;lrinfl(2:t1-24)-lrinfl(1:t1-24-1)],srinfl(25:t1)-srinfl(24:t1-1),infl(25:t1)-infl(24:t1-1),pc1_macvol(25:t1)-pc1_macvol(24:t1-1),pc1_finvol(25:t1)-pc1_finvol(24:t1-1)];
% % crisis sample: from 08:M9 to 18:M9;
% t2 = 225;           % t2 = 225 if the crisis began in Sep 2008, or t2 = 212 if the crisis began in Aug 2007. 
% ydata = tp10(t2:end)-tp10(t2-1:end-1);
% xdata = [ones(345-t2+1,1),ygap(t2:end)-ygap(t2-1:end-1),consconf(t2:end)-consconf(t2-1:end-1),lrinfl(t2-24:end)-lrinfl(t2-24-1:end-1),srinfl(t2:end)-srinfl(t2-1:end-1),infl(t2:end)-infl(t2-1:end-1),pc1_macvol(t2:end)-pc1_macvol(t2-1:end-1),pc1_finvol(t2:end)-pc1_finvol(t2-1:end-1),pdv(t2:end)-pdv(t2-1:end-1)];
% 
% % %%%%%%%%%%% Differencing Regressions, with one lagged change in term premium.%%%%%%%%%
% % ydata = tp10(26:end)-tp10(25:end-1);
% % xdata = [ones(285-25,1),tp10(25:end-1)-tp10(24:end-2),ygap(26:end)-ygap(25:end-1),consconf(26:end)-consconf(25:end-1),[lrinfl(2:end)-lrinfl(1:end-1)],srinfl(26:end)-srinfl(25:end-1),infl(26:end)-infl(25:end-1),logrgdp_disp(26:end)-logrgdp_disp(25:end-1),unemp_disp(26:end)-unemp_disp(25:end-1),infl_disp(26:end)-infl_disp(25:end-1),move(26:end)-move(25:end-1),vix(26:end)-vix(25:end-1),euro6vol(26:end)-euro6vol(25:end-1),pdv(26:end)-pdv(25:end-1)];
% %%% adding lagged tp or diff in tp does not help model fit, but worsens LSAP significance. 

%%%%%%%%%%%%%%%%%%%%%%%%%% Kiefer-Vogelsang (2002) Heteroskedasticity-Autocorrelation Robost Standard Errors.  
[coef,tstat] = ols_kvhac(ydata,xdata);  % Calculate Kiefer-Vogelsan t-statistics. 5% sig value at 4.77 and 2% sig value at 6.09. Same below.  
display('coef =');
display(coef');
disp('Kiefer-Vogelsang t-stat');
display(tstat);
yfit = xdata*coef;
T = size(ydata,1);
display('R square');
display(var(xdata*coef)/var(ydata));
adjR2 = (yfit-mean(yfit))'*(yfit-mean(yfit))/((ydata-mean(ydata))'*(ydata-mean(ydata)))*(T-size(xdata,2))/(T-1);
display('Adjusted R2');
display(adjR2);
display('serial correlation of the regression residuals');
residual = ydata-xdata*coef;
corr = corrcoef(residual(2:end),residual(1:end-1));
corr = corr(1,2);
display(corr);

% Model-implied decomposition:
% With End of Month yield data, choose to examine changes from Aug 2008 till April 2013, since Taper tantrum occurred in mid-May 2013. 
display('change in 10-year term premiums from Aug 2008 to Apr 2013');
display(ydata(280-24)-ydata(224-24));
display('decomposition of regressors');
changefactor = (xdata(280-24,2:end)-xdata(224-24,2:end)).*coef(2:end)';
display(changefactor);

display('Changes in Macro Fundmentals');
display(sum(changefactor(1:5)));
display('Changes in Macro Uncertainties');
display(sum(changefactor(6:8)));
display('Changes in Financial Volatilities and Uncertainties');
display(sum(changefactor(9:11)));
display('Change in LSAP');
display(changefactor(12));

display('Changes in QE I, QE II, MEP, QE III');
change_qe1to3 = coef(end)*[pdv(243)-pdv(226),pdv(258)-pdv(250),pdv(272)-pdv(260),pdv(280)-pdv(272)];
display(change_qe1to3);
display('Change in non-active purchase period');
display(changefactor(12)-sum(change_qe1to3));

display('residual');
display(ydata(280-24)-ydata(224-24)-sum(changefactor));

% CR (2016) starts 98:M1 instead of 92:M1
display('change in 10-year term premiums from Sep 2008 to Apr 2013'); % with End of Month yield data, choose to examine changes till April 2013, since Taper tantrum occurred in mid-May 2013. 
display(ydata(280-24-12*6)-ydata(224-24-12*6));
display('decomposition of regressors')
display((xdata(280-24-12*6,2:end)-xdata(224-24-12*6,2:end)).*coef(2:end)');

%%%%%%%%%% Counter-factural experiment trying to separate forward guidance from LSAP per se
%%%%%%%%%% Sample period from Jan 1992 to Aug 2014, right before the FOMC's announcement on "Policy Normalization Principles and Plans on Sep 17, 2014, when
%%%%%%%%%% QE renormalization is formally de-linked with forward guidance.  
t3 = 345;             % t3 = 296 means the estimation sample ends in Aug. 2014, for col. 3-4; = 345 is Sep. 2018 for cols. 1 and 2 
qe1=zeros(t3,1);    
qe1(227:243)= 1;      % QE1: Nov. 2008 to Mar. 2010;
qe2=zeros(t3,1);    
qe2(251:258)= 1;      % QE2: Nov. 2010 to Jun. 2011;
qe_mep=zeros(t3,1);  
qe_mep(261:272)= 1;   % QE_MEP: Sep. 2011 to Aug. 2012;
qe3=zeros(t3,1);     
qe3(273:296)= 1;      % QE3: Sep. 2012 to Oct. 2014;

% Table 4, Cols 1 and 2, Only use PDV, not PDV_n. Effect of PDV may change over time.  
ydata = tp10(25:t3);
xdata = [ones(t3-25+1,1),ygap(25:t3),consconf(25:t3),lrinfl(1:t3-24),srinfl(25:t3),infl(25:t3),logrgdp_disp(25:t3),unemp_disp(25:t3),infl_disp(25:t3),move(25:t3),vix(25:t3),euro6vol(25:t3),pdv(25:t3),qe1(25:t3).*pdv(25:t3),qe2(25:t3).*pdv(25:t3),qe_mep(25:t3).*pdv(25:t3),qe3(25:t3).*pdv(25:t3)];
% % % % Only use PDV, not PDV_n, and using principal components
ydata = tp10(25:t3);
xdata = [ones(t3-25+1,1),ygap(25:t3),consconf(25:t3),lrinfl(1:t3-24),srinfl(25:t3),infl(25:t3),pc1_macvol(25:t3),pc1_finvol(25:t3),pdv(25:t3),qe1(25:t3).*pdv(25:t3),qe2(25:t3).*pdv(25:t3),qe_mep(25:t3).*pdv(25:t3),qe3(25:t3).*pdv(25:t3)];

% % %%%% differencing, only use PDV
ydata = tp10(25:t3)-tp10(24:t3-1);
xdata = [ones(t3-25+1,1),ygap(25:t3)-ygap(24:t3-1),consconf(25:t3)-consconf(24:t3-1),[0;lrinfl(2:t3-24)-lrinfl(1:t3-24-1)],srinfl(25:t3)-srinfl(24:t3-1),infl(25:t3)-infl(24:t3-1),logrgdp_disp(25:t3)-logrgdp_disp(24:t3-1),unemp_disp(25:t3)-unemp_disp(24:t3-1),infl_disp(25:t3)-infl_disp(24:t3-1),move(25:t3)-move(24:t3-1),vix(25:t3)-vix(24:t3-1),euro6vol(25:t3)-euro6vol(24:t3-1)];
xdata = [xdata,pdv(25:t3)-pdv(24:t3-1),qe1(25:t3).*(pdv(25:t3)-pdv(24:t3-1)),qe2(25:t3).*(pdv(25:t3)-pdv(24:t3-1)),qe_mep(25:t3).*(pdv(25:t3)-pdv(24:t3-1)),qe3(25:t3).*(pdv(25:t3)-pdv(24:t3-1))];
% %%%% differencing, only use PDV, and using principal components
ydata = tp10(25:t3)-tp10(24:t3-1);
xdata = [ones(t3-25+1,1),ygap(25:t3)-ygap(24:t3-1),consconf(25:t3)-consconf(24:t3-1),[0;lrinfl(2:t3-24)-lrinfl(1:t3-24-1)],srinfl(25:t3)-srinfl(24:t3-1),infl(25:t3)-infl(24:t3-1),pc1_macvol(25:t3)-pc1_macvol(24:t3-1),pc1_finvol(25:t3)-pc1_finvol(24:t3-1)];
xdata = [xdata,pdv(25:t3)-pdv(24:t3-1),qe1(25:t3).*(pdv(25:t3)-pdv(24:t3-1)),qe2(25:t3).*(pdv(25:t3)-pdv(24:t3-1)),qe_mep(25:t3).*(pdv(25:t3)-pdv(24:t3-1)),qe3(25:t3).*(pdv(25:t3)-pdv(24:t3-1))];

%% F star test on all four QE dummies are equal -- but not necessarily zero; 
R = zeros(3,size(xdata,2));
R(:,end-3)=ones(3,1);
R(:,end-2:end)=-eye(3);
F_star=fstar_kvhac(ydata,xdata,R,zeros(3,1));
%% F star test on the first three QE dummies are equal - but not necessarily zero; 
R = zeros(2,size(xdata,2));
R(:,end-3)=ones(2,1);
R(:,end-2:end-1)=-eye(2);       
F_star=fstar_kvhac(ydata,xdata,R,zeros(2,1));
%% F star test on the last three QE dummies are equal - but not necessarily zero; 
R = zeros(2,size(xdata,2));
R(:,end-2)=ones(2,1);
R(:,end-1:end)=-eye(2);       
F_star=fstar_kvhac(ydata,xdata,R,zeros(2,1));

% Table 4, Cols 3 and 4, Separating PDV and PDV_N, effect of PDV_N may change over time. 
ydata = tp10(25:t3);
xdata = [ones(t3-25+1,1),ygap(25:t3),consconf(25:t3),lrinfl(1:t3-24),srinfl(25:t3),infl(25:t3),logrgdp_disp(25:t3),unemp_disp(25:t3),infl_disp(25:t3),move(25:t3),vix(25:t3),euro6vol(25:t3),pdv_n(25:t3),qe1(25:t3).*pdv_n(25:t3),qe2(25:t3).*pdv_n(25:t3),qe_mep(25:t3).*pdv_n(25:t3),qe3(25:t3).*pdv_n(25:t3),pdv(25:t3)-pdv_n(25:t3)];
% Separating PDV and PDV_N, and using principal components 
ydata = tp10(25:t3);
xdata = [ones(t3-25+1,1),ygap(25:t3),consconf(25:t3),lrinfl(1:t3-24),srinfl(25:t3),infl(25:t3),pc1_macvol(25:t3),pc1_finvol(25:t3),pdv_n(25:t3),qe1(25:t3).*pdv_n(25:t3),qe2(25:t3).*pdv_n(25:t3),qe_mep(25:t3).*pdv_n(25:t3),qe3(25:t3).*pdv_n(25:t3),pdv(25:t3)-pdv_n(25:t3)];
% % Separating PDV and PDV_N, differencing regression
ydata = tp10(25:t3)-tp10(24:t3-1);
xdata = [ones(t3-25+1,1),ygap(25:t3)-ygap(24:t3-1),consconf(25:t3)-consconf(24:t3-1),[0;lrinfl(2:t3-24)-lrinfl(1:t3-24-1)],srinfl(25:t3)-srinfl(24:t3-1),infl(25:t3)-infl(24:t3-1),logrgdp_disp(25:t3)-logrgdp_disp(24:t3-1),unemp_disp(25:t3)-unemp_disp(24:t3-1),infl_disp(25:t3)-infl_disp(24:t3-1),move(25:t3)-move(24:t3-1),vix(25:t3)-vix(24:t3-1),euro6vol(25:t3)-euro6vol(24:t3-1)];
xdata = [xdata,pdv_n(25:t3)-pdv_n(24:t3-1),qe1(25:t3).*(pdv_n(25:t3)-pdv_n(24:t3-1)),qe2(25:t3).*(pdv_n(25:t3)-pdv_n(24:t3-1)),qe_mep(25:t3).*(pdv_n(25:t3)-pdv_n(24:t3-1)),qe3(25:t3).*(pdv_n(25:t3)-pdv_n(24:t3-1)),(pdv(25:t3)-pdv_n(25:t3))-(pdv(24:t3-1)-pdv_n(24:t3-1))];
% % Separating PDV and PDV_N, using principal components, and differencing regression
ydata = tp10(25:t3)-tp10(24:t3-1);
xdata = [ones(t3-25+1,1),ygap(25:t3)-ygap(24:t3-1),consconf(25:t3)-consconf(24:t3-1),[0;lrinfl(2:t3-24)-lrinfl(1:t3-24-1)],srinfl(25:t3)-srinfl(24:t3-1),infl(25:t3)-infl(24:t3-1),pc1_macvol(25:t3)-pc1_macvol(24:t3-1),pc1_finvol(25:t3)-pc1_finvol(24:t3-1)];
xdata = [xdata,pdv_n(25:t3)-pdv_n(24:t3-1),qe1(25:t3).*(pdv_n(25:t3)-pdv_n(24:t3-1)),qe2(25:t3).*(pdv_n(25:t3)-pdv_n(24:t3-1)),qe_mep(25:t3).*(pdv_n(25:t3)-pdv_n(24:t3-1)),qe3(25:t3).*(pdv_n(25:t3)-pdv_n(24:t3-1)),(pdv(25:t3)-pdv_n(25:t3))-(pdv(24:t3-1)-pdv_n(24:t3-1))];
% % Crisis sample
% t2 = 225;           % t2 = 225 if the crisis began in Sep 2008, or t2 = 212 if the crisis began in Aug 2007. 
% ydata = tp10(t2:t3);
% xdata = [ones(t3-t2+1,1),ygap(t2:t3),consconf(t2:t3),lrinfl(t2-24:t3-24),srinfl(t2:t3),infl(t2:t3),logrgdp_disp(t2:t3),unemp_disp(t2:t3),infl_disp(t2:t3),move(t2:t3),vix(t2:t3),euro6vol(t2:t3),pdv_n(t2:t3),qe1(t2:t3).*pdv_n(t2:t3),qe2(t2:t3).*pdv_n(t2:t3),qe_mep(t2:t3).*pdv_n(t2:t3),qe3(t2:t3).*pdv_n(t2:t3),pdv(t2:t3)-pdv_n(t2:t3)];

%% F star test on all four QE dummies are equal -- but not necessarily zero; 
R = zeros(3,size(xdata,2));
R(:,end-4)=ones(3,1);
R(:,end-3:end-1)=-eye(3);
F_star=fstar_kvhac(ydata,xdata,R,zeros(3,1));
%% F star test on the first three QE dummies are equal - but not necessarily zero; 
R = zeros(2,size(xdata,2));
R(:,end-4)=ones(2,1);
R(:,end-3:end-2)=-eye(2);       
F_star=fstar_kvhac(ydata,xdata,R,zeros(2,1));
%% F star test on the last three QE dummies are equal - but not necessarily zero; 
R = zeros(2,size(xdata,2));
R(:,end-3)=ones(2,1);
R(:,end-2:end-1)=-eye(2);       
F_star=fstar_kvhac(ydata,xdata,R,zeros(2,1));

%% The last two columns (col. 5 and 6) of Table 4, effects of PDV-PDV_N may change over time.  
ydata = tp10(25:t3);
xdata = [ones(t3-25+1,1),ygap(25:t3),consconf(25:t3),lrinfl(1:t3-24),srinfl(25:t3),infl(25:t3),logrgdp_disp(25:t3),unemp_disp(25:t3),infl_disp(25:t3),move(25:t3),vix(25:t3),euro6vol(25:t3),pdv_n(25:t3),pdv(25:t3)-pdv_n(25:t3),qe2(25:t3).*(pdv(25:t3)-pdv_n(25:t3)),qe_mep(25:t3).*(pdv(25:t3)-pdv_n(25:t3)),qe3(25:t3).*(pdv(25:t3)-pdv_n(25:t3))];
% Separating PDV and PDV_N, and using principal components 
ydata = tp10(25:t3);
xdata = [ones(t3-25+1,1),ygap(25:t3),consconf(25:t3),lrinfl(1:t3-24),srinfl(25:t3),infl(25:t3),pc1_macvol(25:t3),pc1_finvol(25:t3),pdv_n(25:t3),pdv(25:t3)-pdv_n(25:t3),qe2(25:t3).*(pdv(25:t3)-pdv_n(25:t3)),qe_mep(25:t3).*(pdv(25:t3)-pdv_n(25:t3)),qe3(25:t3).*(pdv(25:t3)-pdv_n(25:t3))];
% % Separating PDV and PDV_N, differencing regression
ydata = tp10(25:t3)-tp10(24:t3-1);
xdata = [ones(t3-25+1,1),ygap(25:t3)-ygap(24:t3-1),consconf(25:t3)-consconf(24:t3-1),[0;lrinfl(2:t3-24)-lrinfl(1:t3-24-1)],srinfl(25:t3)-srinfl(24:t3-1),infl(25:t3)-infl(24:t3-1),logrgdp_disp(25:t3)-logrgdp_disp(24:t3-1),unemp_disp(25:t3)-unemp_disp(24:t3-1),infl_disp(25:t3)-infl_disp(24:t3-1),move(25:t3)-move(24:t3-1),vix(25:t3)-vix(24:t3-1),euro6vol(25:t3)-euro6vol(24:t3-1)];
pdv_fg_diff=(pdv(25:t3)-pdv_n(25:t3))-(pdv(24:t3-1)-pdv_n(24:t3-1));
xdata = [xdata,pdv_n(25:t3)-pdv_n(24:t3-1),pdv_fg_diff,qe2(25:t3).*pdv_fg_diff,qe_mep(25:t3).*pdv_fg_diff,qe3(25:t3).*pdv_fg_diff];
% % Separating PDV and PDV_N, using principal components, and differencing regression
ydata = tp10(25:t3)-tp10(24:t3-1);
xdata = [ones(t3-25+1,1),ygap(25:t3)-ygap(24:t3-1),consconf(25:t3)-consconf(24:t3-1),[0;lrinfl(2:t3-24)-lrinfl(1:t3-24-1)],srinfl(25:t3)-srinfl(24:t3-1),infl(25:t3)-infl(24:t3-1),pc1_macvol(25:t3)-pc1_macvol(24:t3-1),pc1_finvol(25:t3)-pc1_finvol(24:t3-1)];
pdv_fg_diff=(pdv(25:t3)-pdv_n(25:t3))-(pdv(24:t3-1)-pdv_n(24:t3-1));
xdata = [xdata,pdv_n(25:t3)-pdv_n(24:t3-1),pdv_fg_diff,qe2(25:t3).*pdv_fg_diff,qe_mep(25:t3).*pdv_fg_diff,qe3(25:t3).*pdv_fg_diff];
%% F star test on all four QE dummies (here means QE II, MEP and III, and all equal to zero-- QE I is zero) are equal -- but not necessarily zero; 
R = zeros(3,size(xdata,2));
R(1,end-2) = 1;
R(2:3,end-2)=ones(2,1);
R(2:3,end-1:end)=-eye(2);
F_star=fstar_kvhac(ydata,xdata,R,zeros(3,1));
%% F star test on the first three QE dummies (here only two since QE I cannot be tested, and all equal to zero)  are equal - but not necessarily zero; 
R = zeros(2,size(xdata,2));
R(1,end-2) = 1;
R(2,end-2:end-1)=[1,-1];  
F_star=fstar_kvhac(ydata,xdata,R,zeros(2,1));
%% F star test on the last three QE dummies are equal - but not necessarily zero; 
R = zeros(2,size(xdata,2));
R(:,end-2)=ones(2,1);
R(:,end-1:end)=-eye(2);       
F_star=fstar_kvhac(ydata,xdata,R,zeros(2,1));
